#````````````````````````````
#  fR[h
#````````````````````````````
sub decode {
	&ReadParse;

	foreach (keys %in) {
		if ($_ ne 'img') {

			$in{$_} =~ tr/+/ /;
			$in{$_} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$in{$_} =~ s/&/&amp;/g;
			$in{$_} =~ s/"/&quot;/g;
			$in{$_} =~ s/'/&#39;/g;
			$in{$_} =~ s/\//&#47;/g;
			$in{$_} =~ s/\./&#8901;/g;
			$in{$_} =~ s/</&lt;/g;
			$in{$_} =~ s/>/&gt;/g;
			$in{$_} =~ s/\t/  /g;
			$in{$_} =~ s/\0//g;

			&jcode::convert(\$in{$_}, 'sjis');
		}
	}

	return %in;
}

#````````````````````````````
#  [M
#````````````````````````````
sub sendmail {
	my ($to, $from, $subject, $body) = @_;

	&jcode::convert(\$from,'jis');
	&jcode::convert(\$subject,'jis');
	&jcode::convert(\$body,'jis');

	$from = &mimeencode($from);
	$subject = &mimeencode($subject);

	open (MAIL,"| $sendmail -t") || &error("SendmailG[");
		print MAIL "To: $to\n";
		print MAIL "From: $from <$to>\n";
		print MAIL "Subject: $subject\n";
		print MAIL "MIME-Version: 1.0\n";
		print MAIL "Content-Transfer-Encoding: 7bit\n";
		print MAIL "Content-Type: text/html\; charset=\"ISO-2022-JP\"\n\n";
		print MAIL $body;
	close (MAIL);
}

#````````````````````````````
#  t@Cǂݍ
#````````````````````````````
sub file_read {
	my ($file) = @_;

	open (FILE, "$file") || &error("t@C\"$file\"J܂łB");
		flock (FILE, 1) if ($lock == 1);
		my @line = <FILE>;
	close (FILE);

	chomp (@line);

	return @line;
}

#````````````````````````````
#  t@C
#````````````````````````````
sub file_write {
	my ($file, @data) = @_;

	open (FILE, "+< $file") || &error("t@C\"$file\"J܂łB");
	flock (FILE, 2) if ($lock == 1);
	seek (FILE, 0, 0) if ($lock == 1);
	foreach (@data) {
		print FILE "$_\n";
	}
	truncate (FILE, tell (FILE)) if ($lock == 1);
	close (FILE);
}

#````````````````````````````
#  t@C݁iVK쐬j
#````````````````````````````
sub new_file_write {
	my ($file, @data) = @_;

	open (FILE, ">$file") || &error("t@C\"$file\"J܂łB");
		foreach (@data) {
			print FILE "$_\n";
		}
	close (FILE);
}

#````````````````````````````
#  tl
#````````````````````````````
sub get_days {
	my ($sec, $min, $hour, $dy, $mon, $year, $wday, $yday, $isdst) = gmtime(time+60*60*9);
	my @week = ('','','','','','','y');

	$days = sprintf("%04d/%01d/%01d\(%s\) %02d:%02d", $year+1900, $mon+1, $dy, $week[$wday], $hour, $min);

	return $days;
}

#````````````````````````````
#  wb_[
#````````````````````````````
sub header {
	print "Content-type: text/html\n\n";
	print <<"_HTML_";
<html>
<head>
<meta http-equiv="Content-type" content="text/html; charset=shift_jis">
<title>WEB</title>
<link rel="stylesheet" type="text/css" href="$style">
<script language="javascript">
<!--
function quotation(message) {
	if (document.getElementById('bold').checked == true) {
		document.getElementById('restext').value = "<b>> "+message+"</b>\\n"+document.getElementById('restext').value;
	} else {
		document.getElementById('restext').value = "> "+message+"\\n"+document.getElementById('restext').value;
	}
}
// -->
</script>
</head>
<body>
_HTML_
}

#````````````````````````````
#  tb^[
#````````````````````````````
sub footer {
	print <<"_HTML_";
<div align="right">
<font size="-2">
<a href="http://goo.gl/kxtdN" target="_blank">܂₩WEB Ver1.50</a>
</font></div>
</body>
</html>
_HTML_
}

#````````````````````````````
#  bN
#````````````````````````````
sub lock {
	# 3ȏÂbN͉
	if (-e $lockdir) {
		my $mtime = (stat($lockdir))[9];
		if ($mtime < time - 60*3) { &unlock; }
	}

	my $retry = 5;

	while (!mkdir($lockdir, 0755)) {
		if (--$retry <= 0) {
			&error('rW[ԂłB΂炭҂ĂēxMĂB');
		}
		sleep(1);
	}

	$lockflg = 1;
}

#````````````````````````````
#  bN
#````````````````````````````
sub unlock {
	rmdir($lockdir);
	$lockflg = 0;
}

#````````````````````````````
#  G[
#````````````````````````````
sub error {
	&unlock if ($lockflg);

	&header('error');

	print "<p><table><tr><td><font color=\"#CC3333\">G[</font><br>\n";

	foreach (@_) {
		print "<font color=\"#CC3333\">&gt;&nbsp;</font>$_<br>\n";
	}

	print "</tr></td></table></p>\n";
	print "<a href=\"JavaScript:history.back()\">߂</a>\n";
	print "</body></html>\n";
	exit;
}
1;